#TEMPLATE(ScottRipley,'Scott Ripley Templates'),FAMILY('ABC')
#! -------------------------------------------------------------------------
#EXTENSION(JSRMultiTimer, 'Allow Multiple Timers on a Window'),DESCRIPTION( 'Set up multiple timers on a window'),WINDOW
#DISPLAY('')
#DISPLAY('Multi-Timer by Ripley Software')
#DISPLAY('')
#DISPLAY('The multiple timers are controlled by the JSR_TimerClass')
#DISPLAY('object found in JSRTIMER.INC and JSRTIMER.CLW.')
#DISPLAY('The window you are defining will have it''s own instance')
#DISPLAY('of the JSR_TimerClass object so you need to get it a name.')
#PROMPT('Your timer class object: ',@S255),%JSRTimer,DEFAULT('MyTimer')
#DISPLAY('')
#DISPLAY('By checking the following box the description of')
#DISPLAY('the currently active timer can be put on the window')
#DISPLAY('using the Prop:Text attribute of the control you specify:')
#PROMPT('Show Active Timer?',CHECK),%JSRTimerPutDescOnWindow
#ENABLE(%JSRTimerPutDescOnWindow)
#PROMPT('Control to use: ',CONTROL),%JSRActiveTimerControl
#ENDENABLE
#DISPLAY('')
#DISPLAY('Add your timers below')
#BUTTON('Timers'),MULTI(%JSRTimers,%JSRTimerLabel & ' (' & %JSRTimerTime & ') ' & %JSRTimerDesc),INLINE
  #PROMPT('Timer Label',@s40),%JSRTimerLabel,REQ
  #PROMPT('Timer (1/100th seconds)',@s10),%JSRTimerTime,REQ
  #PROMPT('Timer Description',@s255),%JSRTimerDesc
  #PROMPT('Turn timer on at startup',CHECK),%JSRTimerIsOn,DEFAULT(1)
#ENDBUTTON
#AT(%ModuleDataSection),FIRST
  INCLUDE('JSRTIMER.INC'),ONCE
#ENDAT
#AT(%DataSectionBeforeWindow)
%[22]JSRTimer CLASS(JSR_TimerClass)
#FOR(%JSRTimers)
%[24]JSRTimerLabel LONG  ! %JSRTimerDesc
#ENDFOR
#EMBED(%JSRTimerProperties,'JSR Timer Class - Additional properties')
Add_My_Timers          PROCEDURE,VIRTUAL
Timer_Proc             PROCEDURE,VIRTUAL
#EMBED(%JSRTimerMethods,'JSR Timer Class - Additional Methods')
                     END
#ENDAT
#AT(%AcceptLoopBeforeEventHandling)
%JSRTimer.CheckTimers
#ENDAT
#AT(%AfterWindowOpening)
  %JSRTimer.Init(%Window)
  %JSRTimer.SelfName = '%JSRTimer'
  #IF(%JSRTimerPutDescOnWindow AND %JSRActiveTimerControl)
  %JSRTimer.DisplayCtrl = %JSRActiveTimerControl
  #ENDIF
#ENDAT
#AT(%EndOfProcedure)
  %JSRTimer.Kill
#ENDAT
#AT(%LocalProcedures)
%JSRTimer.Add_My_Timers PROCEDURE
#EMBED(%JSRAddTimersData,'Add_My_Timers Data Section')
  CODE
#EMBED(%JSRAddTimersPreCode,'Add_My_Timers before generated code')
  #FOR(%JSRTimers)
  Self.%JSRTimerLabel = %JSRTimer.AddTimer(%JSRTimerTime, '%JSRTimerDesc')
  #IF(%JSRTimerIsOn)
  Self.On(Self.%JSRTimerLabel)
  #ENDIF
  #ENDFOR
#EMBED(%JSRAddTimersPreCode,'Add_My_Timers after generated code')
  RETURN

%JSRTimer.Timer_Proc PROCEDURE
#EMBED(%JSRTimerProcData,'Timer_Proc Data Section')
  CODE
#EMBED(%JSRTimerProcBeforeCase,'Timer_Proc Before generated code')
  CASE Self.ActiveTimer
  #FOR(%JSRTimers)
  #SUSPEND
  #?OF Self.%JSRTimerLabel          ! Interval=%JSRTimerTime    %JSRTimerDesc
    #EMBED(%JSRTimerProcCaseOF,'Timer Code'),%JSRTimerDesc
  #RESUME
  #ENDFOR
  END
#EMBED(%JSRTimerProcAfterCase,'Timer_Proc After generated code')
  RETURN
#ENDAT
